! Subroutine to solve lower triangular system by forward substitution
subroutine forward_subs(l,b,x,n)
integer,intent(in) :: n
real,intent(in) :: l(n,n),b(n)
real,intent(out) :: x(n)
integer :: k,s
real :: p
x(1) = b(1)/l(1,1)
do k = 2,n
  p = 0.0
  do s = 1, k-1
    p = p + l(k,s)*x(s)
  enddo
  x(k) = (b(k) - p)/l(k,k)
enddo
return
end

!
program forward_subs_driver
integer :: n
parameter (n=3)
real :: l(n,n),b(n),x(n)
data l/1.0,1.0,1.0,0.0,1.0,1.0,0.0,0.0,1.0/
data b/1.0,2.0,3.0/
call forward_subs(l,b,x,n)
write(*,*)'x',x
stop
end

   
