! Program to do naive gauss elimination
! page 143 ; Kincaid and Cheney
subroutine ngauss(a,b,n)
! On input, a will contain the lhs matrix. On return it will
! have the upper triangular GE transformation
! In input b will have the rhs; on output the result 
real,intent(inout) :: a(n,n),b(n)
real :: z
integer :: k
do k = 1,n-1
  do i = k+1,n
    z= a(i,k)/a(k,k)
    a(i,k) = 0.0
    do j = k+1,n
      a(i,j) = a(i,j) - z*a(k,j)
    enddo
      b(i) = b(i) - z*b(k)
  enddo
enddo
! Now solve the UT system
b(n) = b(n)/a(n,n)
do k = n-1,1,-1
  z = 0.0
  do j = n,k+1,-1
    z = z + a(k,j)*b(j)
  enddo
  b(k) = (b(k) - z)/a(k,k)
enddo
return
end
!
program ngauss_driver
parameter (n=4)
integer :: n
real :: a(n,n),b(n)
data a/6,12,3,-6,-2,-8,-13,4,2,6,9,1,4,10,3,-18/
data b/12,34,27,-38/
call ngauss(a,b,n)
write(*,*)'a',a
write(*,*)'b',b
stop
end


