! Subroutine to solve a tridiagonal system pg. 154 Kincaid & Cheney
! Main diagonal is d<sub>i, i =1,n ; sub diagonal  is a<sub>i, i = 1,n-1
! Super diagonal is c<sub>i, i =1, n-1
! RHS is b ; result is in x
subroutine tridiag(a,b,c,d,x,n)
integer,intent(in) :: n
real,intent(inout) :: a(n),b(n),c(n),d(n)
real,intent(out) :: x(n)
integer :: i
real :: z
! Forward sweep
do i = 2,n
  z = a(i-1)/d(i-1)
  d(i) = d(i) - z*c(i-1)
  b(i) = b(i) - z*b(i-1)
enddo
! Backward sweep
x(n) = b(n)/d(n)
do i = n-1,1,-1
  x(i) = (b(i) - c(i)*x(i+1))/d(i)
enddo
return
end
!
program tridiag_driver
integer :: n
parameter(n=4)
real :: a(n),b(n),c(n),d(n),x(n)
data d/3,3,3,3/,b/2,1,1,2/,a/-1,-1,-1,-1/,c/-1,-1,-1,-1/
call tridiag(a,b,c,d,x,n)
write(*,*)'x',x
stop
end
