! Subroutine to solve upper triangular system by backward substitution
subroutine backward_subs(u,b,x,n)
integer,intent(in) :: n
real,intent(in) :: u(n,n),b(n)
real,intent(out) :: x(n)
integer :: k,s
real :: p
x(n) = b(n)/u(n,n)
do k = n-1,1,-1
  p = 0.0
  do s = k+1,n
    p = p + u(k,s)*x(s)
  enddo
  x(k) = (b(k) - p)/u(k,k)
enddo
return
end

!
program backward_subs_driver
integer :: n
parameter (n=3)
real :: u(n,n),b(n),x(n)
data u/1.0,0.0,0.0,1.0,1.0,0.0,1.0,1.0,1.0/
data b/3.0,2.0,1.0/
call backward_subs(u,b,x,n)
write(*,*)'x',x
stop
end

   
